2 # Copyright (c) 2005 Junio C Hamano
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
14 # You should have received a copy of the GNU General Public License
15 # along with this program. If not, see http://www.gnu.org/licenses/ .
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18 echo "Error: The notmuch test suite requires a bash version >= 4.0"
19 echo "due to use of associative arrays within the test suite."
20 echo "Please try again with a newer bash (or help us fix the"
21 echo "test suite to be more portable). Thanks."
25 # if --tee was passed, write the output not only to the terminal, but
26 # additionally to the file test-results/$BASENAME.out, too.
27 case "$GIT_TEST_TEE_STARTED, $* " in
29 # do not redirect again
31 *' --tee '*|*' --va'*)
33 BASE=test-results/$(basename "$0" .sh)
34 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
35 echo $? > $BASE.exit) | tee $BASE.out
36 test "$(cat $BASE.exit)" = 0
41 # Keep the original TERM for say_color and test_emacs
44 # dtach(1) provides more capable terminal environment to anything
45 # that requires more than dumb terminal...
46 [ x"${TERM:-dumb}" = xdumb ] && DTACH_TERM=vt100 || DTACH_TERM=$TERM
48 # For repeatability, reset the environment to known value.
54 export LANG LC_ALL PAGER TERM TZ
55 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
56 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
57 ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
58 echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
61 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
62 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
72 # A regexp to match 5 and 40 hexdigits
73 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
74 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
76 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
77 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
79 # Each test should start with something like this, after copyright notices:
81 # test_description='Description of this test...
82 # This test checks if command xyzzy does the right thing...
85 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
86 TERM=$ORIGINAL_TERM &&
89 tput bold >/dev/null 2>&1 &&
90 tput setaf 1 >/dev/null 2>&1 &&
91 tput sgr0 >/dev/null 2>&1
98 -d|--d|--de|--deb|--debu|--debug)
100 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
101 immediate=t; shift ;;
102 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
103 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
104 -h|--h|--he|--hel|--help)
106 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
108 -q|--q|--qu|--qui|--quie|--quiet)
111 with_dashes=t; shift ;;
117 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
118 valgrind=t; verbose=t; shift ;;
120 shift ;; # was handled already
122 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
125 echo "error: unknown test option '$1'" >&2; exit 1 ;;
129 if test -n "$debug"; then
131 printf " %-4s" "[$((test_count - 1))]"
139 if test -n "$color"; then
145 error) tput bold; tput setaf 1;; # bold red
146 skip) tput bold; tput setaf 2;; # bold green
147 pass) tput setaf 2;; # green
148 info) tput setaf 3;; # brown
149 *) test -n "$quiet" && return;;
160 test -z "$1" && test -n "$quiet" && return
169 say_color error "error: $*\n"
178 test "${test_description}" != "" ||
179 error "Test script did not set test_description."
181 if test "$help" = "t"
183 echo "Tests ${test_description}"
187 echo $(basename "$0"): "Testing ${test_description}"
201 rm -rf "$TEST_TMPDIR"
206 if test -n "$GIT_EXIT_OK"
211 say_color error '%-6s' FATAL
212 echo " $test_subtest_name"
214 echo "Unexpected exit while executing $0. Exit code $code."
221 echo >&5 "FATAL: $0: interrupted by signal" $((code - 128))
226 # Note: TEST_TMPDIR *NOT* exported!
227 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
229 trap 'die_signal' HUP INT TERM
231 test_decode_color () {
232 sed -e 's/.\[1m/<WHITE>/g' \
233 -e 's/.\[31m/<RED>/g' \
234 -e 's/.\[32m/<GREEN>/g' \
235 -e 's/.\[33m/<YELLOW>/g' \
236 -e 's/.\[34m/<BLUE>/g' \
237 -e 's/.\[35m/<MAGENTA>/g' \
238 -e 's/.\[36m/<CYAN>/g' \
239 -e 's/.\[m/<RESET>/g'
251 sed -e 's/$/Q/' | tr Q '\015'
255 tr '\015' Q | sed -e 's/Q$//'
258 # Generate a new message in the mail directory, with a unique message
259 # ID and subject. The message is not added to the index.
261 # After this function returns, the filename of the generated message
262 # is available as $gen_msg_filename and the message ID is available as
265 # This function supports named parameters with the bash syntax for
266 # assigning a value to an associative array ([name]=value). The
267 # supported parameters are:
269 # [dir]=directory/of/choice
271 # Generate the message in directory 'directory/of/choice' within
272 # the mail store. The directory will be created if necessary.
276 # Store the message in file 'name'. The default is to store it
277 # in 'msg-<count>', where <count> is three-digit number of the
282 # Text to use as the body of the email message
284 # '[from]="Some User <user@example.com>"'
285 # '[to]="Some User <user@example.com>"'
286 # '[subject]="Subject of email message"'
287 # '[date]="RFC 822 Date"'
289 # Values for email headers. If not provided, default values will
290 # be generated instead.
292 # '[cc]="Some User <user@example.com>"'
293 # [reply-to]=some-address
294 # [in-reply-to]=<message-id>
295 # [references]=<message-id>
296 # [content-type]=content-type-specification
297 # '[header]=full header line, including keyword'
299 # Additional values for email headers. If these are not provided
300 # then the relevant headers will simply not appear in the
305 # Controls the message-id of the created message.
311 # This is our (bash-specific) magic for doing named parameters
312 local -A template="($@)"
313 local additional_headers
315 gen_msg_cnt=$((gen_msg_cnt + 1))
316 if [ -z "${template[filename]}" ]; then
317 gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
319 gen_msg_name=${template[filename]}
322 if [ -z "${template[id]}" ]; then
323 gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
325 gen_msg_id="${template[id]}"
328 if [ -z "${template[dir]}" ]; then
329 gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
331 gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
332 mkdir -p "$(dirname "$gen_msg_filename")"
335 if [ -z "${template[body]}" ]; then
336 template[body]="This is just a test message (#${gen_msg_cnt})"
339 if [ -z "${template[from]}" ]; then
340 template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
343 if [ -z "${template[to]}" ]; then
344 template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
347 if [ -z "${template[subject]}" ]; then
348 if [ -n "$test_subtest_name" ]; then
349 template[subject]="$test_subtest_name"
351 template[subject]="Test message #${gen_msg_cnt}"
355 if [ -z "${template[date]}" ]; then
356 template[date]="Fri, 05 Jan 2001 15:43:57 +0000"
359 additional_headers=""
360 if [ ! -z "${template[header]}" ]; then
361 additional_headers="${template[header]}
362 ${additional_headers}"
365 if [ ! -z "${template[reply-to]}" ]; then
366 additional_headers="Reply-To: ${template[reply-to]}
367 ${additional_headers}"
370 if [ ! -z "${template[in-reply-to]}" ]; then
371 additional_headers="In-Reply-To: ${template[in-reply-to]}
372 ${additional_headers}"
375 if [ ! -z "${template[cc]}" ]; then
376 additional_headers="Cc: ${template[cc]}
377 ${additional_headers}"
380 if [ ! -z "${template[bcc]}" ]; then
381 additional_headers="Bcc: ${template[bcc]}
382 ${additional_headers}"
385 if [ ! -z "${template[references]}" ]; then
386 additional_headers="References: ${template[references]}
387 ${additional_headers}"
390 if [ ! -z "${template[content-type]}" ]; then
391 additional_headers="Content-Type: ${template[content-type]}
392 ${additional_headers}"
395 if [ ! -z "${template[content-transfer-encoding]}" ]; then
396 additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
397 ${additional_headers}"
400 # Note that in the way we're setting it above and using it below,
401 # `additional_headers' will also serve as the header / body separator
402 # (empty line in between).
404 cat <<EOF >"$gen_msg_filename"
405 From: ${template[from]}
407 Message-Id: <${gen_msg_id}>
408 Subject: ${template[subject]}
409 Date: ${template[date]}
410 ${additional_headers}
415 # Generate a new message and add it to the database.
417 # All of the arguments and return values supported by generate_message
418 # are also supported here, so see that function for details.
421 generate_message "$@" &&
422 notmuch new > /dev/null
425 # Deliver a message with emacs and add it to the database
427 # Uses emacs to generate and deliver a message to the mail store.
428 # Accepts arbitrary extra emacs/elisp functions to modify the message
429 # before sending, which is useful to doing things like attaching files
430 # to the message and encrypting/signing.
431 emacs_deliver_message ()
436 # before we can send a message, we have to prepare the FCC maildir
437 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
438 # eval'ing smtp-dummy --background will set smtp_dummy_pid
440 eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
441 test -n "$smtp_dummy_pid" || return 1
444 "(let ((message-send-mail-function 'message-smtpmail-send-it)
445 (smtpmail-smtp-server \"localhost\")
446 (smtpmail-smtp-service \"25025\"))
450 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
451 (message-goto-subject)
452 (insert \"${subject}\")
456 (message-send-and-exit))"
458 # In case message was sent properly, client waits for confirmation
459 # before exiting and resuming control here; therefore making sure
460 # that server exits by sending (KILL) signal to it is safe.
461 kill -9 $smtp_dummy_pid
462 notmuch new >/dev/null
465 # Generate a corpus of email and add it to the database.
467 # This corpus is fixed, (it happens to be 50 messages from early in
468 # the history of the notmuch mailing list), which allows for reliably
469 # testing commands that need to operate on a not-totally-trivial
470 # number of messages.
474 if [ -d $TEST_DIRECTORY/corpus.mail ]; then
475 cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
477 cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
478 notmuch new >/dev/null
479 cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
483 test_begin_subtest ()
485 if [ -n "$inside_subtest" ]; then
486 exec 1>&6 2>&7 # Restore stdout and stderr
487 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
489 test_subtest_name="$1"
491 # Remember stdout and stderr file descriptors and redirect test
492 # output to the previously prepared file descriptors 3 and 4 (see
494 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
495 exec 6>&1 7>&2 >&3 2>&4
499 # Pass test if two arguments match
501 # Note: Unlike all other test_expect_* functions, this function does
502 # not accept a test name. Instead, the caller should call
503 # test_begin_subtest before calling this function in order to set the
507 exec 1>&6 2>&7 # Restore stdout and stderr
509 test "$#" = 3 && { prereq=$1; shift; } || prereq=
511 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
515 if ! test_skip "$test_subtest_name"
517 if [ "$output" = "$expected" ]; then
520 testname=$this_test.$test_count
521 echo "$expected" > $testname.expected
522 echo "$output" > $testname.output
523 test_failure_ "$(diff -u $testname.expected $testname.output)"
528 # Like test_expect_equal, but takes two filenames.
529 test_expect_equal_file ()
531 exec 1>&6 2>&7 # Restore stdout and stderr
533 test "$#" = 3 && { prereq=$1; shift; } || prereq=
535 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
538 basename1=`basename "$file1"`
540 basename2=`basename "$file2"`
541 if ! test_skip "$test_subtest_name"
543 if diff -q "$file1" "$file2" >/dev/null ; then
546 testname=$this_test.$test_count
547 cp "$file1" "$testname.$basename1"
548 cp "$file2" "$testname.$basename2"
549 test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
554 # Like test_expect_equal, but arguments are JSON expressions to be
555 # canonicalized before diff'ing. If an argument cannot be parsed, it
556 # is used unchanged so that there's something to diff against.
557 test_expect_equal_json () {
558 # The test suite forces LC_ALL=C, but this causes Python 3 to
559 # decode stdin as ASCII. We need to read JSON in UTF-8, so
560 # override Python's stdio encoding defaults.
561 output=$(echo "$1" | PYTHONIOENCODING=utf-8 python -mjson.tool \
563 expected=$(echo "$2" | PYTHONIOENCODING=utf-8 python -mjson.tool \
566 test_expect_equal "$output" "$expected" "$@"
569 test_emacs_expect_t () {
570 test "$#" = 2 && { prereq=$1; shift; } || prereq=
572 error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
575 if ! test_skip "$test_subtest_name"
577 test_emacs "(notmuch-test-run $1)" >/dev/null
579 # Restore state after the test.
580 exec 1>&6 2>&7 # Restore stdout and stderr
583 # Report success/failure.
589 test_failure_ "${result}"
592 # Restore state after the (non) test.
593 exec 1>&6 2>&7 # Restore stdout and stderr
600 notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
603 notmuch_search_sanitize ()
605 perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
608 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
609 notmuch_show_sanitize ()
611 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
613 notmuch_show_sanitize_all ()
616 -e 's| filename:.*| filename:XXXXX|' \
617 -e 's| id:[^ ]* | id:XXXXX |'
620 notmuch_json_show_sanitize ()
623 -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
624 -e 's|"filename": "/[^"]*",|"filename": "YYYYY",|g'
627 # End of notmuch helper functions
629 # Use test_set_prereq to tell that a particular prerequisite is available.
630 # The prerequisite can later be checked for in two ways:
632 # - Explicitly using test_have_prereq.
634 # - Implicitly by specifying the prerequisite tag in the calls to
635 # test_expect_{success,failure,code}.
637 # The single parameter is the prerequisite tag (a simple word, in all
638 # capital letters by convention).
641 satisfied="$satisfied$1 "
645 test_have_prereq () {
654 declare -A test_missing_external_prereq_
655 declare -A test_subtest_missing_external_prereq_
657 # declare prerequisite for the given external binary
658 test_declare_external_prereq () {
660 test "$#" = 2 && name=$2 || name="$binary(1)"
662 if ! hash $binary 2>/dev/null; then
663 test_missing_external_prereq_["${binary}"]=t
666 test_subtest_missing_external_prereq_[\"${name}\"]=t
672 # Explicitly require external prerequisite. Useful when binary is
673 # called indirectly (e.g. from emacs).
674 # Returns success if dependency is available, failure otherwise.
675 test_require_external_prereq () {
677 if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
678 # dependency is missing, call the replacement function to note it
685 # You are not expected to call test_ok_ and test_failure_ directly, use
686 # the text_expect_* functions instead.
689 if test "$test_subtest_known_broken_" = "t"; then
690 test_known_broken_ok_
693 test_success=$(($test_success + 1))
694 say_color pass "%-6s" "PASS"
695 echo " $test_subtest_name"
699 if test "$test_subtest_known_broken_" = "t"; then
700 test_known_broken_failure_ "$@"
703 test_failure=$(($test_failure + 1))
704 test_failure_message_ "FAIL" "$test_subtest_name" "$@"
705 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
709 test_failure_message_ () {
710 say_color error "%-6s" "$1"
713 echo "$@" | sed -e 's/^/ /'
714 if test "$verbose" != "t"; then cat test.output; fi
717 test_known_broken_ok_ () {
719 test_fixed=$(($test_fixed+1))
720 say_color pass "%-6s" "FIXED"
721 echo " $test_subtest_name"
724 test_known_broken_failure_ () {
726 test_broken=$(($test_broken+1))
727 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
732 test "$debug" = "" || eval "$1"
737 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
740 eval >&3 2>&4 "$test_cleanup"
745 test_count=$(($test_count+1))
747 for skp in $NOTMUCH_SKIP_TESTS
749 case $this_test.$test_count in
754 if test -z "$to_skip" && test -n "$prereq" &&
755 ! test_have_prereq "$prereq"
761 test_report_skip_ "$@"
764 test_check_missing_external_prereqs_ "$@"
769 test_check_missing_external_prereqs_ () {
770 if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
771 say_color skip >&1 "missing prerequisites: "
772 echo ${!test_subtest_missing_external_prereq_[@]} >&1
773 test_report_skip_ "$@"
779 test_report_skip_ () {
781 say_color skip >&3 "skipping test:"
783 say_color skip "%-6s" "SKIP"
787 test_subtest_known_broken () {
788 test_subtest_known_broken_=t
791 test_expect_success () {
792 test "$#" = 3 && { prereq=$1; shift; } || prereq=
794 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
795 test_subtest_name="$1"
801 # test_run_ may update missing external prerequisites
802 test_check_missing_external_prereqs_ "$@" ||
803 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
812 test_expect_code () {
813 test "$#" = 4 && { prereq=$1; shift; } || prereq=
815 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
816 test_subtest_name="$2"
822 # test_run_ may update missing external prerequisites,
823 test_check_missing_external_prereqs_ "$@" ||
824 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
828 test_failure_ "exit code $eval_ret, expected $1" "$3"
833 # test_external runs external test scripts that provide continuous
834 # test output about their progress, and succeeds/fails on
835 # zero/non-zero exit code. It outputs the test output on stdout even
836 # in non-verbose mode, and announces the external script with "* run
837 # <n>: ..." before running it. When providing relative paths, keep in
838 # mind that all scripts run in "trash directory".
839 # Usage: test_external description command arguments...
840 # Example: test_external 'Perl API' perl ../path/to/test.pl
842 test "$#" = 4 && { prereq=$1; shift; } || prereq=
844 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
845 test_subtest_name="$1"
848 if ! test_skip "$test_subtest_name" "$@"
850 # Announce the script to reduce confusion about the
851 # test output that follows.
852 say_color "" " run $test_count: $descr ($*)"
853 # Run command; redirect its stderr to &4 as in
854 # test_run_, but keep its stdout on our stdout even in
866 # Like test_external, but in addition tests that the command generated
867 # no output on stderr.
868 test_external_without_stderr () {
869 # The temporary file has no (and must have no) security
871 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
872 stderr="$tmp/git-external-stderr.$$.tmp"
873 test_external "$@" 4> "$stderr"
874 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
875 test_subtest_name="no stderr: $1"
877 if [ ! -s "$stderr" ]; then
881 if [ "$verbose" = t ]; then
882 output=`echo; echo Stderr is:; cat "$stderr"`
886 # rm first in case test_failure exits.
888 test_failure_ "$@" "$output"
892 # This is not among top-level (test_expect_success)
893 # but is a prefix that can be used in the test script, like:
895 # test_expect_success 'complain and die' '
897 # do something else &&
898 # test_must_fail git checkout ../outerspace
901 # Writing this as "! git checkout ../outerspace" is wrong, because
902 # the failure could be due to a segv. We want a controlled failure.
906 test $? -gt 0 -a $? -le 129 -o $? -gt 192
909 # test_cmp is a helper function to compare actual and expected output.
910 # You can use it like:
912 # test_expect_success 'foo works' '
913 # echo expected >expected &&
915 # test_cmp expected actual
918 # This could be written as either "cmp" or "diff -u", but:
919 # - cmp's output is not nearly as easy to read as diff -u
920 # - not all diff versions understand "-u"
926 # This function can be used to schedule some commands to be run
927 # unconditionally at the end of the test to restore sanity:
929 # test_expect_success 'test core.capslock' '
930 # git config core.capslock true &&
931 # test_when_finished "git config --unset core.capslock" &&
935 # That would be roughly equivalent to
937 # test_expect_success 'test core.capslock' '
938 # git config core.capslock true &&
940 # git config --unset core.capslock
943 # except that the greeting and config --unset must both succeed for
946 test_when_finished () {
948 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
953 test_results_dir="$TEST_DIRECTORY/test-results"
954 mkdir -p "$test_results_dir"
955 test_results_path="$test_results_dir/${0%.sh}"
957 echo "total $test_count" >> $test_results_path
958 echo "success $test_success" >> $test_results_path
959 echo "fixed $test_fixed" >> $test_results_path
960 echo "broken $test_broken" >> $test_results_path
961 echo "failed $test_failure" >> $test_results_path
962 echo "" >> $test_results_path
966 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
968 if [ "$test_failure" = "0" ]; then
969 if [ "$test_broken" = "0" ]; then
978 emacs_generate_script () {
979 # Construct a little test script here for the benefit of the user,
980 # (who can easily run "run_emacs" to get the same emacs environment
981 # for investigating any failures).
982 cat <<EOF >"$TMP_DIRECTORY/run_emacs"
985 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
987 # Here's what we are using here:
989 # --no-init-file Don't load users ~/.emacs
991 # --no-site-file Don't load the site-wide startup stuff
993 # --directory Ensure that the local elisp sources are found
995 # --load Force loading of notmuch.el and test-lib.el
997 exec ${TEST_EMACS} --no-init-file --no-site-file \
998 --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
999 --directory "$TEST_DIRECTORY" --load test-lib.el \
1002 chmod a+x "$TMP_DIRECTORY/run_emacs"
1006 # test dependencies beforehand to avoid the waiting loop below
1007 missing_dependencies=
1008 test_require_external_prereq dtach || missing_dependencies=1
1009 test_require_external_prereq emacs || missing_dependencies=1
1010 test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1011 test -z "$missing_dependencies" || return
1013 if [ -z "$EMACS_SERVER" ]; then
1014 emacs_tests="$(basename $0).el"
1015 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
1016 load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1020 server_name="notmuch-test-suite-$$"
1021 # start a detached session with an emacs server
1022 # user's TERM (or 'vt100' in case user's TERM is unset, empty
1023 # or 'dumb') is given to dtach which assumes a minimally
1024 # VT100-compatible terminal -- and emacs inherits that
1025 TERM=$DTACH_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1026 sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1027 --no-window-system \
1029 --eval '(setq server-name \"$server_name\")' \
1030 --eval '(server-start)' \
1031 --eval '(orphan-watchdog $$)'" || return
1032 EMACS_SERVER="$server_name"
1033 # wait until the emacs server is up
1034 until test_emacs '()' >/dev/null 2>/dev/null; do
1039 # Clear test-output output file. Most Emacs tests end with a
1040 # call to (test-output). If the test code fails with an
1041 # exception before this call, the output file won't get
1042 # updated. Since we don't want to compare against an output
1043 # file from another test, so start out with an empty file.
1047 ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(progn $@)"
1051 export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1052 export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
1054 # Some distros (e.g. Arch Linux) ship Python 2.* as /usr/bin/python2,
1055 # most others as /usr/bin/python. So first try python2, and fallback to
1056 # python if python2 doesn't exist.
1058 [[ ${test_missing_external_prereq_[python2]} == t ]] && cmd=python
1060 (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
1064 # Creates a script that counts how much time it is executed and calls
1065 # notmuch. $notmuch_counter_command is set to the path to the
1066 # generated script. Use notmuch_counter_value() function to get the
1067 # current counter value.
1068 notmuch_counter_reset () {
1069 notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1070 if [ ! -x "$notmuch_counter_command" ]; then
1071 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1072 cat >"$notmuch_counter_command" <<EOF || return
1075 read count < "$notmuch_counter_state_path"
1076 echo \$((count + 1)) > "$notmuch_counter_state_path"
1080 chmod +x "$notmuch_counter_command" || return
1083 echo 0 > "$notmuch_counter_state_path"
1086 # Returns the current notmuch counter value.
1087 notmuch_counter_value () {
1088 if [ -r "$notmuch_counter_state_path" ]; then
1089 read count < "$notmuch_counter_state_path"
1096 test_reset_state_ () {
1097 test -z "$test_init_done_" && test_init_
1099 test_subtest_known_broken_=
1100 test_subtest_missing_external_prereq_=()
1103 # called once before the first subtest
1107 # skip all tests if there were external prerequisites missing during init
1108 test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1112 . ./test-lib-common.sh
1114 emacs_generate_script
1117 # Use -P to resolve symlinks in our working directory so that the cwd
1118 # in subprocesses like git equals our $PWD (for pathname comparisons).
1119 cd -P "$test" || error "Cannot setup test environment"
1121 if test "$verbose" = "t"
1125 exec 4>test.output 3>&4
1129 for skp in $NOTMUCH_SKIP_TESTS
1132 for skp in $NOTMUCH_SKIP_TESTS
1134 case "$this_test" in
1141 say_color skip >&3 "skipping test $this_test altogether"
1142 say_color skip "skip all tests in $this_test"
1147 # Provide an implementation of the 'yes' utility
1162 # Fix some commands on Windows
1165 # Windows has its own (incompatible) sort and find
1175 # git sees Windows-style pwd
1179 # no POSIX permissions
1180 # backslashes in pathspec are converted to '/'
1181 # exec does not inherit the PID
1184 test_set_prereq POSIXPERM
1185 test_set_prereq BSLASHPSPEC
1186 test_set_prereq EXECKEEPSPID
1190 test -z "$NO_PERL" && test_set_prereq PERL
1191 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1193 # test whether the filesystem supports symbolic links
1194 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1197 # declare prerequisites for external binaries used in tests
1198 test_declare_external_prereq dtach
1199 test_declare_external_prereq emacs
1200 test_declare_external_prereq ${TEST_EMACSCLIENT}
1201 test_declare_external_prereq gdb
1202 test_declare_external_prereq gpg
1203 test_declare_external_prereq python
1204 test_declare_external_prereq python2